# このプログラムは何ですか

Universal Monitor ( https://electrelic.com/electrelic/node/1317 )のCP-1600への移植版です。移植は Kasumi YOSHINO <ykasumi@spamex.com> が行いました。

# CP-1600版固有の特徴

## Sコマンド

CP-1600は16ビット/語なので(*)、メモリ内容は（1バイト分の2桁ではなく）4桁の16進数で表示されます。また、入力するメモリの値として、16ビット値を受け付けます。

(*)正確にいえば、実際に使われるのは16ビット中の下位10ビット分で、上位6ビットは予約されています

## Dコマンド

Sコマンドと同様に、メモリダンプ時にはメモリ内容は4桁の16進数で表示されます。また、他のCPU向けのUniversal Monitorと同じく、ダンプ開始アドレスと終了アドレスを指定した場合には、それらが含まれるように開始アドレスや終了アドレスが再計算されます。これはメモリダンプの開始アドレスを0か8の倍数にして読み易くするためです。

通常のメモリダンプの右側に、ASCIIダンプ（ASCII表示）が表示されます。この場合、メモリの16ビット値の上位8ビット、下位8ビットの値にそれぞれ相当するASCIIコードの文字（ただしコントロール文字や、0x80以上の文字は全て"."になります）が、この順番で表示されます。例えば、0x4142という値は、ASCIIダンプではABと表示されます。

## Lコマンド

インテルHex形式（I8HEX）およびモトローラS-Record形式（S19）の両方をサポートします（自動判別）。インテルHex形式の場合、アドレスフィールドの値はバイトアドレスであることを想定しており、内部処理で値を1/2にしてワードアドレスに変換しています。ただし、コマンドラインで与えるロードアドレスのオフセット値は、他のコマンドと同様に、ワードアドレスであることに注意してください。

```
【マクロアセンブラASを使っている方へ追記】
標準添付のp2hexは、インテルHex形式ではアドレスフィールドにバイトアドレスをセットしますが、モトローラS-Record形式ではワードアドレスをセットします。
```

## その他のコマンド

S, D, GおよびLコマンド以外のコマンドは実装されていません。

# モニタプログラムのビルド

## アセンブラ

The Macro Assembler AS（http://john.ccac.rwth-aachen.de:8000/as/）のバージョン1.42b ビルド223か、それ以後を使ってください。これより古いバージョンでは、PACKING疑似命令をサポートしていないので、ソースファイルをアセンブルできません。

## コンソールドライバ

現時点では16550 UART用のみです。

## コンフィギュレーション

リセットがかかった時、CP-1600はバスからプログラムの開始アドレスをロードします。この開始アドレスは、外部の回路によって与えられます（メモリ上の割り込みベクタテーブルの値ではありません）。作者自作のCP-1600ブレッドボードコンピュータではバスをプルダウンしているため開始アドレスは0x0000になっていますが、もしご自分の環境では異なるようなら、*unimon_cp1600.asm* の中で `ORG  X'0000'` を含む行を修正してください。
